<?php
/**
 * Perforce Swarm
 *
 * @copyright   2013-2019 Perforce Software. All rights reserved.
 * @license     Please see LICENSE.txt in top-level readme folder of this distribution.
 * @version     2019.1/1829459
 */

return array(
    'router' => array(
        'routes' => array(
            'api' => array(
                'type' => 'literal',
                'options' => array(
                    'route' => '/api',
                ),
                'may_terminate' => false,
                'child_routes' => array(
                    'version' => array(
                        'type' => 'Zend\Router\Http\Segment',
                        'options' => array(
                            'route' => '/[:version/]version[/]',
                            'constraints' => array('version' => 'v([2-9]|1(\.[1-2])?)'),
                            'defaults' => array(
                                'controller' => Api\Controller\IndexController::class,
                                'action'     => 'version'
                            ),
                        ),
                    ),
                    'logout' => array(
                        'type' => 'Zend\Router\Http\Segment',
                        'options' => array(
                            'route' => '/:version/logout[/]',
                            'constraints' => array('version' => 'v9'),
                        ),
                        'child_routes' => array(
                            'user' => array(
                                'type' => 'Zend\Router\Http\Method',
                                'options' => array (
                                    'verb' => 'post',
                                    'defaults' => array(
                                        'controller' => Api\Controller\LoginController::class,
                                        'action'     => 'logout'
                                    ),
                                ),
                            ),
                        ),
                    ),
                    'login' => array(
                        'type' => 'Zend\Router\Http\Segment',
                        'options' => array(
                            'route' => '/:version/login[/]',
                            'constraints' => array('version' => 'v9'),
                        ),
                        'child_routes' => array(
                            'user' => array(
                                'type' => 'Zend\Router\Http\Method',
                                'options' => array (
                                    'verb' => 'post',
                                    'defaults' => array(
                                        'controller' => Api\Controller\LoginController::class,
                                        'action'     => 'login'
                                    ),
                                ),
                            ),
                            'samlResponse' => array(
                                'type' => 'Zend\Router\Http\Segment',
                                'options' => array(
                                    'route' => 'saml/response[/]',
                                    'constraints' => array('version' => 'v9'),
                                ),
                                'child_routes' => array(
                                    'samlResponse' => array(
                                        'type' => 'Zend\Router\Http\Method',
                                        'options' => array (
                                            'verb' => 'post',
                                            'defaults' => array(
                                                'controller' => Api\Controller\LoginController::class,
                                                'action'     => 'samlResponse'
                                            ),
                                        ),
                                    ),
                                ),
                            ),
                            'samlLogin' => array(
                                'type' => 'Zend\Router\Http\Segment',
                                'options' => array(
                                    'route' => 'saml[/]',
                                    'constraints' => array('version' => 'v9'),
                                ),
                                'child_routes' => array(
                                    'samlLogin' => array(
                                        'type' => 'Zend\Router\Http\Method',
                                        'options' => array (
                                            'verb' => 'post',
                                            'defaults' => array(
                                                'controller' => Api\Controller\LoginController::class,
                                                'action'     => 'samlLogin'
                                            ),
                                        ),
                                    ),
                                ),
                            ),
                            'listmethods' => array(
                                'type' => 'Zend\Router\Http\Segment',
                                'options' => array(
                                    'route' => 'listmethods[/]',
                                    'constraints' => array('version' => 'v9'),
                                ),
                                'child_routes' => array(
                                    'listmethods' => array(
                                        'type' => 'Zend\Router\Http\Method',
                                        'options' => array (
                                            'verb' => 'get',
                                            'defaults' => array(
                                                'controller' => Api\Controller\LoginController::class,
                                                'action'     => 'listMethods'
                                            ),
                                        ),
                                    ),
                                ),
                            ),
                            'initauth' => array(
                                'type' => 'Zend\Router\Http\Segment',
                                'options' => array(
                                    'route' => 'initauth[/]',
                                    'constraints' => array('version' => 'v9'),
                                ),
                                'child_routes' => array(
                                    'initauth' => array(
                                        'type' => 'Zend\Router\Http\Method',
                                        'options' => array (
                                            'verb' => 'post',
                                            'defaults' => array(
                                                'controller' => Api\Controller\LoginController::class,
                                                'action'     => 'initAuth'
                                            ),
                                        ),
                                    ),
                                ),
                            ),
                            'checkauth' => array(
                                'type' => 'Zend\Router\Http\Segment',
                                'options' => array(
                                    'route' => 'checkauth[/]',
                                    'constraints' => array('version' => 'v9'),
                                ),
                                'child_routes' => array(
                                    'checkauthpoll' => array(
                                        'type' => 'Zend\Router\Http\Method',
                                        'options' => array (
                                            'verb' => 'get',
                                            'defaults' => array(
                                                'controller' => Api\Controller\LoginController::class,
                                                'action'     => 'checkAuthPoll'
                                            ),
                                        ),
                                    ),
                                    'checkauth' => array(
                                        'type' => 'Zend\Router\Http\Method',
                                        'options' => array (
                                            'verb' => 'post',
                                            'defaults' => array(
                                                'controller' => Api\Controller\LoginController::class,
                                                'action'     => 'checkAuth'
                                            ),
                                        ),
                                    ),
                                ),
                            ),
                        ),
                    ),
                    'activity' => array(
                        'type' => 'Zend\Router\Http\Segment',
                        'may_terminate' => true,
                        'options' => array(
                            'route' => '/:version/activity[/]',
                            'constraints' => array('version' => 'v([2-9]|1(\.[1-2])?)'),
                            'defaults' => array(
                                'controller' => Api\Controller\ActivityController::class,
                            ),
                        ),
                    ),
                    'comments' => array(
                        'type' => 'Zend\Router\Http\Segment',
                        'may_terminate' => true,
                        'options' => array(
                            'route' => '/:version/comments[/]',
                            'constraints' => array('version' => 'v([3-9])'),
                            'defaults' => array(
                                'controller' => Api\Controller\CommentsController::class,
                            ),
                        ),
                        'child_routes' => array(
                            'comment' => array(
                                'type' => 'Application\Router\Regex',
                                'options' => array(
                                    'regex'    => '/?(?P<id>[0-9\(\)]+)[/]?',
                                    'spec'     => '/comments/%id%',
                                ),
                            ),
                        ),
                    ),
                    'commentsV9' => array(
                        'type' => 'Zend\Router\Http\Segment',
                        'may_terminate' => false,
                        'options' => array(
                            'route' => '/:version/comments[/]',
                            'constraints' => array('version' => 'v9'),
                            'defaults' => array(
                                'controller' => Api\Controller\CommentsController::class,
                            ),
                        ),
                        'child_routes' => array(
                            'markallread' => array(
                                'type' => 'Zend\Router\Http\Segment',
                                'may_terminate' => false,
                                'options' => array(
                                    'route'    => '[/]read[/]',
                                ),
                                'child_routes' => array(
                                    'markallread-post' => array(
                                        'may_terminate' => true,
                                        'type' => 'Zend\Router\Http\Method',
                                        'options' => array (
                                            'verb' => 'post',
                                            'defaults' => array(
                                                'action'     => 'markAllRead',
                                            ),
                                        ),
                                    ),
                                ),
                            ),
                            'markallunread' => array(
                                'type' => 'Zend\Router\Http\Segment',
                                'options' => array(
                                    'route'    => '[/]unread[/]',
                                ),
                                'child_routes' => array(
                                    'markallunread-post' => array(
                                        'may_terminate' => true,
                                        'type' => 'Zend\Router\Http\Method',
                                        'options' => array (
                                            'verb' => 'post',
                                            'defaults' => array(
                                                'action'     => 'markAllUnread',
                                            ),
                                        ),
                                    ),
                                ),
                            ),
                            'notify' => array(
                                'type' => 'Zend\Router\Http\Segment',
                                'may_terminate' => false,
                                'options' => array(
                                    'route' => '[/]notify[/]',
                                ),
                                'child_routes' => array(
                                    'notify-post' => array(
                                        'may_terminate' => true,
                                        'type' => 'Zend\Router\Http\Method',
                                        'options' => array (
                                            'verb' => 'post',
                                            'defaults' => array(
                                                'action'     => 'sendAllMyDelayedComments',
                                            ),
                                        ),
                                    ),
                                ),
                            ),
                        ),
                    ),
                    'projects' => array(
                        'type' => 'Zend\Router\Http\Segment',
                        'may_terminate' => true,
                        'options' => array(
                            'route' => '/:version/projects[/:id][/]',
                            'constraints' => array('version' => 'v([2-9]|1(\.[1-2])?)'),
                            'defaults' => array(
                                'controller' => Api\Controller\ProjectsController::class,
                            ),
                        ),
                    ),
                    'groups' => array(
                        'type' => 'Zend\Router\Http\Segment',
                        'options' => array(
                            'route' => '/:version/groups[/:id][/]',
                            'constraints' => array('version' => 'v([2-9])'),
                            'defaults' => array(
                                'controller' => Api\Controller\GroupsController::class,
                            ),
                        ),
                    ),
                    'dashboard' => array(
                        'type' => 'Zend\Router\Http\Segment',
                        'options' => array(
                            'route' => '/:version/dashboards/action',
                            'constraints' => array('version' => 'v([6-9])'),
                        ),
                        'child_routes' => array(
                            'review-dashboard' => array(
                                'type' => 'Zend\Router\Http\Method',
                                'options' => array (
                                    'verb' => 'get',
                                    'defaults' => array(
                                        'controller' => Api\Controller\ReviewsController::class,
                                        'action'     => 'dashboard',
                                        'author'     => null
                                    ),
                                ),
                            ),
                        ),
                    ),
                    'reviews' => array(
                        'type' => 'Zend\Router\Http\Segment',
                        'options' => array(
                            'route' => '/:version/reviews[/:id][/]',
                            'constraints' => array('version' => 'v(9|8|7|6|5|4|3|2|1(\.[1-2])?)'),
                            'defaults' => array(
                                'controller' => Api\Controller\ReviewsController::class,
                            ),
                        ),
                    ),
                    'reviews/archive' => array(
                        'type' => 'Zend\Router\Http\Segment',
                        'options' => array(
                            'route' => '/:version/reviews/archive[/]',
                            'constraints' => array('version' => 'v([6-9])'),
                            'defaults' => array(
                                'controller' => Api\Controller\ReviewsController::class,
                                'action'     => 'archiveInactive',
                            ),
                        ),
                    ),
                    'reviews/changes' => array(
                        'type' => 'Zend\Router\Http\Segment',
                        'options' => array(
                            'route' => '/:version/reviews/:id/changes[/]',
                            'constraints' => array('version' => 'v([2-9]|1(\.[1-2])?)'),
                            'defaults' => array(
                                'controller'    => Api\Controller\ReviewsController::class,
                                'action'        => 'addChange',
                                'addChangeMode' => null
                            ),
                        ),
                    ),
                    'reviews/state' => array(
                        'type' => 'Zend\Router\Http\Segment',
                        'options' => array(
                            'route' => '/:version/reviews/:id/state[/]',
                            'constraints' => array('version' => 'v([2-9])'),
                            'defaults' => array(
                                'controller' => Api\Controller\ReviewsController::class,
                                'action'     => 'state',
                            ),
                        ),
                    ),
                    'reviews/cleanup' => array(
                        'type' => 'Zend\Router\Http\Segment',
                        'options' => array(
                            'route' => '/:version/reviews/:id/cleanup[/]',
                            'constraints' => array('version' => 'v([6-9])'),
                            'defaults' => array(
                                'controller' => Api\Controller\ReviewsController::class,
                                'action'     => 'cleanup',
                            ),
                        ),
                    ),
                    'reviews/vote' => array(
                        'type' => 'Zend\Router\Http\Segment',
                        'options' => array(
                            'route' => '/:version/reviews/:id/vote[/]',
                            'constraints' => array('version' => 'v9'),
                            'defaults' => array(
                                'controller' => Api\Controller\ReviewsController::class,
                                'action' => 'vote',
                            ),
                        ),
                        'child_routes' => array(
                            'review-vote' => array(
                                'type' => 'Zend\Router\Http\Method',
                                'options' => array (
                                    'verb' => 'post',
                                ),
                            ),
                        ),
                    ),
                    'users' => array(
                        'type' => 'Zend\Router\Http\Segment',
                        'options' => array(
                            'route' => '/:version/users[/]',
                            'constraints' => array('version' => 'v9'),
                            'defaults' => array(
                                'controller' => Api\Controller\UsersController::class,
                            ),
                        ),
                    ),
                    'reviews/obliterate' => array(
                        'type' => 'Zend\Router\Http\Segment',
                        'options' => array(
                            'route' => '/:version/reviews/:id/obliterate[/]',
                            'constraints' => array('version' => 'v(9)'),
                            'defaults' => array(
                                'controller' => Api\Controller\ReviewsController::class,
                                'action'     => 'obliterate',
                            ),
                        ),
                    ),
                    'reviews/transitions' => array(
                        'type' => 'Zend\Router\Http\Segment',
                        'options' => array(
                            'route' => '/:version/reviews/:id/transitions[/]',
                            'constraints' => array('version' => 'v(9)'),
                            'defaults' => array(
                                'controller' => Api\Controller\ReviewsController::class,
                            ),
                        ),
                        'child_routes' => array(
                            'review-transitions' => array(
                                'type' => 'Zend\Router\Http\Method',
                                'options' => array (
                                    'verb' => 'GET',
                                    'defaults' => array(
                                        'action'     => 'transitions',
                                    ),
                                ),
                            ),
                        ),
                    ),
                    'servers' => array(
                        'type' => 'Zend\Router\Http\Segment',
                        'options' => array(
                            'route' => '/:version/servers[/]',
                            'constraints' => array('version' => 'v9'),
                        ),
                        'child_routes' => array(
                            'servers-all' => array(
                                'type' => 'Zend\Router\Http\Method',
                                'options' => array (
                                    'verb' => 'get',
                                    'defaults' => array(
                                        'controller' => Api\Controller\ServersController::class,
                                    ),
                                ),
                            ),
                        ),
                    ),
                    'session' => array(
                        'type' => 'Zend\Router\Http\Segment',
                        'options' => array(
                            'route' => '/:version/session[/]',
                            'constraints' => array('version' => 'v(9)'),
                        ),
                        'child_routes' => array(
                            'session-transitions' => array(
                                'type' => 'Zend\Router\Http\Method',
                                'options' => array (
                                    'verb' => 'delete, get, post',
                                    'defaults' => array(
                                        'controller' => Api\Controller\LoginController::class,
                                    ),
                                ),
                            ),
                        ),
                    ),
                    'users/unfollowall' => array(
                        'type' => 'Zend\Router\Http\Segment',
                        'options' => array(
                            'route' => '/:version/users/:user/unfollowall[/]',
                            'constraints' => array('version' => 'v([8-9])'),
                        ),
                        'child_routes' => array(
                            'users-unfollowall' => array(
                                'type' => 'Zend\Router\Http\Method',
                                'options' => array (
                                    'verb' => 'post',
                                    'defaults' => array(
                                        'controller' => Api\Controller\UsersController::class,
                                        'action'     => 'unfollowAll',
                                    ),
                                ),
                            ),
                        ),
                    ),
                    'change/defaultreviewers' => array(
                        'type' => 'Zend\Router\Http\Segment',
                        'options' => array(
                            'route' => '/:version/changes/:change/defaultreviewers[/]',
                            'constraints' => array('version' => 'v([8-9])'),
                            'defaults' => array(
                                'controller' => Api\Controller\ChangesController::class,
                                'action'     => 'defaultReviewers'
                            ),
                        ),
                    ),
                    'change/affects' => array(
                        'type' => 'Zend\Router\Http\Segment',
                        'options' => array(
                            'route' => '/:version/changes/:change/affectsprojects[/]',
                            'constraints' => array('version' => 'v([8-9])'),
                            'defaults' => array(
                                'controller' => Api\Controller\ChangesController::class,
                                'action'     => 'affectsProjects'
                            ),
                        ),
                    ),
                    'change/check' => array(
                        'type' => 'Zend\Router\Http\Segment',
                        'options' => array(
                            'route' => '/:version/changes/:change/check[/]',
                            'constraints' => array('version' => 'v9'),
                            'defaults' => array(
                                'controller' => Api\Controller\ChangesController::class,
                                'action' => 'check',
                            ),
                        ),
                        'child_routes' => array(
                            'change-check' => array(
                                'type' => 'Zend\Router\Http\Method',
                                'options' => array (
                                    'verb' => 'GET',
                                ),
                            ),
                        ),
                    ),
                    'workflows' => array(
                        'type' => 'Zend\Router\Http\Segment',
                        'options' => array(
                            'route' => '/:version/workflows[/]',
                            'constraints' => array('version' => 'v9'),
                        ),
                        'child_routes' => array(
                            'workflows-all' => array(
                                'type' => 'Zend\Router\Http\Method',
                                'options' => array (
                                    'verb' => 'get, post',
                                    'defaults' => array(
                                        'controller' => Api\Controller\WorkflowsController::class,
                                    ),
                                ),
                            ),
                        ),
                    ),
                    'workflow' => array(
                        'type' => 'Zend\Router\Http\Segment',
                        'options' => array(
                            'route' => '/:version/workflows/:id[/]',
                            'constraints' => array('version' => 'v9'),
                        ),
                        'child_routes' => array(
                            'workflow-id' => array(
                                'type' => 'Zend\Router\Http\Method',
                                'options' => array (
                                    'verb' => 'get, patch, put, delete',
                                    'defaults' => array(
                                        'controller' => Api\Controller\WorkflowsController::class
                                    ),
                                ),
                            ),
                        ),
                    ),
                    'notfound' => array(
                        'type' => 'Zend\Router\Http\Regex',
                        'priority' => -100,
                        'options' => array(
                            'regex' => '/(?P<path>.*)|$',
                            'spec'  => '/%path%',
                            'defaults' => array(
                                'controller' => Api\Controller\IndexController::class,
                                'action'     => 'notFound',
                            ),
                        ),
                    ),
                ),
            ),
        ),
    ),
    'controllers' => array(
        'factories' => array_fill_keys(
            [Api\Controller\ActivityController::class,
            Api\Controller\IndexController::class,
            Api\Controller\LoginController::class,
            Api\Controller\ProjectsController::class,
            Api\Controller\ReviewsController::class,
            Api\Controller\GroupsController::class,
            Api\Controller\CommentsController::class,
            Api\Controller\UsersController::class,
            Api\Controller\ChangesController::class,
            Api\Controller\ServersController::class,
            Api\Controller\WorkflowsController::class],
            Application\Controller\IndexControllerFactory::class
        )
    ),
    'security' => array(
        'login_exempt' => array(
            'api/version',
            'api/servers/servers-all',
            'api/login/user',
            'api/users',
            'api/session/session-transitions',
            'api/login/samlLogin/samlLogin'
        ),
        'login_with_cookie' => array('api/change/check/change-check')
    ),
);
