<?php
/**
 * Perforce Swarm
 *
 * @copyright   2013-2019 Perforce Software. All rights reserved.
 * @license     Please see LICENSE.txt in top-level readme folder of this distribution.
 * @version     2019.1/1829459
 */

return array(
    'router' => array(
        'routes' => array(
            'comments' => array(
                'type' => 'Application\Router\Regex',
                'options' => array(
                    'regex'    => '/comments?(/(?P<topic>.*))?',
                    'spec'     => '/comments/%topic%',
                    'defaults' => array(
                        'controller' => Comments\Controller\IndexController::class,
                        'action'     => 'index',
                        'topic'      => null
                    ),
                ),
            ),
            'add-comment' => array(
                'type' => 'Zend\Router\Http\Segment',
                'options' => array(
                    'route'    => '/comment[s]/add[/]',
                    'defaults' => array(
                        'controller' => Comments\Controller\IndexController::class,
                        'action'     => 'add'
                    ),
                ),
            ),
            'edit-comment' => array(
                'type' => 'Zend\Router\Http\Segment',
                'options' => array(
                    'route'    => '/comment[s]/edit/:comment[/]',
                    'defaults' => array(
                        'controller' => Comments\Controller\IndexController::class,
                        'action'     => 'edit'
                    ),
                ),
            ),
        ),
    ),
    'controllers' => array(
        'factories' => [
            Comments\Controller\IndexController::class => Application\Controller\IndexControllerFactory::class,
        ],
    ),
    'view_manager' => array(
        'template_path_stack'   => array(
            __DIR__ . '/../view',
        ),
    ),
    'view_helpers' => array(
        'factories' => [
            Application\View\Helper\ViewHelperFactory::COMMENTS => Application\View\Helper\ViewHelperFactory::class,
        ],
    ),
    'mentions' => array(
        'mode'            => 'global',     // one of 'disabled' 'global' 'projects'.
                                           // If disabled - no @mentioning will be enabled,
                                           // 'global' - enables @mention dropdown in all comment sections
                                           // 'projects' - enables dropdown in comment sections in a project
                                           // that are part of a project
        'usersBlacklist'  => array(),      // array of users that should never end up on the user @mention dropdown
        'groupsBlacklist' => array(),      // array of groups that should never end up on the user @mention dropdown.
                                           // Supports wildcard expansion eg. "foo*".
    ),
    'comments' => array(
        'threading' => array(
            'max_depth' => 4
        ),
        'show_id'    => false,
        'notification_delay_time' => 1800,               // Default to 30 minutes 1800 seconds.
    )
);
