<?php
/**
 * Perforce Swarm
 *
 * @copyright   2013-2019 Perforce Software. All rights reserved.
 * @license     Please see LICENSE.txt in top-level readme folder of this distribution.
 * @version     2019.1/1829459
 */

return array(
    'router' => array(
        'routes' => array(
            'job' => array(
                'type' => 'Application\Router\Regex',
                'options' => array(
                    'regex'    => '/jobs?(/(?P<job>.*))?',
                    'spec'     => '/jobs/%job%',
                    'defaults' => array(
                        'controller' => Jobs\Controller\IndexController::class,
                        'action'     => 'job',
                        'job'        => null
                    ),
                ),
            ),
            'jobs' => array(
                'type' => 'Application\Router\Regex',
                'options' => array(
                    'regex'    => '/jobs?(/(?P<job>.*))?',
                    'spec'     => '/jobs/%job%',
                    'defaults' => array(
                        'controller' => Jobs\Controller\IndexController::class,
                        'action'     => 'job',
                        'job'        => null
                    ),
                ),
            ),
        ),
    ),
    'controllers' => array(
        'factories' => [
            Jobs\Controller\IndexController::class => Application\Controller\IndexControllerFactory::class
        ],
    ),
    'view_manager' => array(
        'template_map' => array(
            'jobs/index/index'  => __DIR__ . '/../view/jobs/index/job.phtml',
        ),
        'template_path_stack'   => array(
            __DIR__ . '/../view',
        ),
    ),
);
